package cz.cvut.fel.pr2.lab07;


public interface BinaryMinHeap {
    
    /**
     * Deletes all elements in the heap. Thus, it will be empty.
     */
    public void clear();
    
    /** 
     * Adds a value to the min-heap.
     * @param value 
     */      
    public void add(int value);

    /** 
     * Tests if the priority queue is empty.
     * @return true if the heap has no elements; false otherwise.
     */       
    public boolean isEmpty();
    
    /**
     * Returns (but does not remove) the minimum element in the heap.
     * @return the minimum element of the priority queue
     * @throws IllegalStateException if priority queue is empty
     */     
    public int peek();

    /**
     * Removes and returns the minimum element in the heap.
     * @return the minimum element of the priority queue
     * @throws IllegalStateException if priority queue is empty
     */       
    public int remove();
    
    /**
     * Searches for the root element in the heap.
     * @return -1 if the heap is empty; otherwise the index of the root element
     */
    public int getRootIndex();
    
    /**
     * Searches for the index of left child of given parent node's index
     * @param index of the parent
     * @return -1 if there is no left child; otherwise index of the left child
     */
    public int getLeftChildIndex(int index);
    
    /**
     * Searches for the index of right child of given parent node's index
     * @param index of the parent
     * @return -1 if there is no right child; otherwise index of the right child
     */
    public int getRightChildIndex(int index);
    
    /**
     * Searches for the value at given node's index
     * @param index of the node
     * @return value of the node
     * @throws IllegalStateException if the index is invalid
     */
    public int getValueAt(int index);
}
